//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include "ieopensavedlg.hpp"
#include "ieview.hpp"
#include "imageenview.hpp"
#include <Vcl.Buttons.hpp>
#include <Vcl.ExtCtrls.hpp>
#include "imageenproc.hpp"
#include "cspin.h"
#include "cxContainer.hpp"
#include "cxControls.hpp"
#include "cxEdit.hpp"
#include "cxGraphics.hpp"
#include "cxLookAndFeelPainters.hpp"
#include "cxLookAndFeels.hpp"
#include "cxMaskEdit.hpp"
#include "cxSpinEdit.hpp"
#include "cxTextEdit.hpp"
#include "dxSkinBlack.hpp"
struct rgbStru
   {
   BYTE r;
   BYTE g;
   BYTE b;
   };
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TImageEnView *PaintView;
	TOpenImageEnDialog *openDialog;
	TSpeedButton *SpeedButton1;
	TSpeedButton *SpeedButton2;
	TImageEnProc *ienProc;
	TLabel *Label1;
	TLabel *Label2;
	TSpeedButton *SpeedButton3;
	TcxSpinEdit *editMult;
	TcxSpinEdit *editBias;
	TLabel *Label3;
	TCheckBox *chkTotConv;
	TComboBox *comboFilter;
	TPanel *Panel2;
	TPanel *Panel3;
	TPanel *Panel4;
	TLabel *Label4;
	TSpeedButton *SpeedButton4;
	TSaveImageEnDialog *saveDialog;
	void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall SpeedButton2Click(TObject *Sender);
	void __fastcall SpeedButton3Click(TObject *Sender);
	void __fastcall SpeedButton4Click(TObject *Sender);
private:	// User declarations
	TIEBitmap *grayScale, *editImage, *origImage;
	float **gS;
	BYTE **rC, **gC, **bC;
	int fHighPass[3][3];
	int fTopHat[3][3];
	float convChans[3], totConv;
	int _ii, _jj;
	BYTE __fastcall normColor(int pixel);
	void __fastcall doConvolve(void);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
